Xref: feenix.metronet.com comp.unix.shell:3576 comp.unix.questions:9341
Newsgroups: comp.unix.shell,comp.unix.questions
Path: feenix.metronet.com!news.ecn.bgu.edu!usenet.ins.cwru.edu!agate!boulder!wraeththu.cs.colorado.edu!tchrist
From: Tom Christiansen <tchrist@cs.Colorado.EDU>
Subject: Re: Any idea about how to change what 'w' shows?
Message-ID: <1993Aug13.124906.6885@colorado.edu>
Originator: tchrist@wraeththu.cs.colorado.edu
Sender: news@colorado.edu (The Daily Planet)
Nntp-Posting-Host: wraeththu.cs.colorado.edu
Reply-To: tchrist@cs.colorado.edu (Tom Christiansen)
Organization: University of Colorado, Boulder
References: <93224.213922U51830@uicvm.uic.edu>
Date: Fri, 13 Aug 1993 12:49:06 GMT
Lines: 36

From the keyboard of Sofia Kourkouvis <U51830@uicvm.uic.edu>:
:I'm being catapulted into a SunOs 4.1.2 environment and I'm having a little
:trouble with the idea that any casual user on our system could easily see
:what I'm doing withe the w command, right down to the names of the files I'm
:downloading or the newsgroups I'm reading with trn.

'w' sometimes shows the "wrong" thing, if other processes with higher
pids are running on that tty.

Now, there are ways of spoofing 'w' by fudging up argv[0], but that won't
help you with commands like 'ps c' which look at u.u_comm saved away
in the kernel and unchangeable.  For example, 

    #!/usr/bin/perl
    # spoof -- tchrist@cs.colorado.edu
    # spoof a command name (but not its args) for w and ps, but not 'ps c'
    die "usage spoof realcmd fakecmd [args ....]\n" unless @ARGV > 1;
    $fakecmd = shift; $realcmd = shift;
    exec $realcmd $fakecmd, @ARGV;
    die "can't exec $realcmd: $!";

It's been said that UNIX probably has more ways of watching what other
people are doing than any other operating system ever, and I don't doubt.
If people want to waste their time watching me, I don't care.  You are
either going to have to learn to get over it, or simply stop using UNIX.

Mind you, there may in theory be some higher level security systems that
restrict this, but at C2 level, you can still see these things.  At B
level this may be different, but remember that security times convenience
would seem to be a constant, so the more that you restrict security in
things like this, the more that you hamstring yourself in other ways you
haven't notice yet.  It's not worth the hassle.

--tom
-- 
    Tom Christiansen      tchrist@cs.colorado.edu       303-444-3212
